# svn_txdelta_window_t Struct Reference
[Text deltas]

An svn_txdelta_window_t object describes how to reconstruct a contiguous section of the target string (the "target view") using a specified contiguous region of the source string (the "source view"). More...

`#include <svn_delta.h>`

## Data Fields
svn_filesize_t | sview_offset
| The offset of the source view for this window.
apr_size_t | sview_len
| The length of the source view for this window.
apr_size_t | tview_len
| The length of the target view for this window, i.e.
int | num_ops
| The number of instructions in this window.
int | src_ops
| The number of svn_txdelta_source instructions in this window.
const svn_txdelta_op_t * | ops
| The instructions for this window.
const svn_string_t * | new_data
| New data, for use by any `svn_txdelta_new' instructions.

## Detailed Description

An svn_txdelta_window_t object describes how to reconstruct a contiguous section of the target string (the "target view") using a specified contiguous region of the source string (the "source view").

It contains a series of instructions which assemble the new target string text by pulling together substrings from:

- the source view,

- the previously constructed portion of the target view,

- a string of new data contained within the window structure

The source view must always slide forward from one window to the next; that is, neither the beginning nor the end of the source view may move to the left as we read from a window stream. This property allows us to apply deltas to non-seekable source streams without making a full copy of the source stream.

Definition at line 188 of file svn_delta.h.

## Field Documentation

const svn_string_t* svn_txdelta_window_t::new_data

New data, for use by any `svn_txdelta_new' instructions.

Definition at line 214 of file svn_delta.h.

int svn_txdelta_window_t::num_ops

The number of instructions in this window.

Definition at line 202 of file svn_delta.h.

const svn_txdelta_op_t* svn_txdelta_window_t::ops

The instructions for this window.

Definition at line 211 of file svn_delta.h.

int svn_txdelta_window_t::src_ops

The number of svn_txdelta_source instructions in this window.

If this number is 0, we don't need to read the source in order to reconstruct the target view.

Definition at line 208 of file svn_delta.h.

apr_size_t svn_txdelta_window_t::sview_len

The length of the source view for this window.

Definition at line 195 of file svn_delta.h.

svn_filesize_t svn_txdelta_window_t::sview_offset

The offset of the source view for this window.

Definition at line 192 of file svn_delta.h.

apr_size_t svn_txdelta_window_t::tview_len

The length of the target view for this window, i.e.

the number of bytes which will be reconstructed by the instruction stream.

Definition at line 199 of file svn_delta.h.

The documentation for this struct was generated from the following file:

- svn_delta.h

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines